/*
	:								SPI.c
	:						   SPI   AVR
	:							 
	:							24.10.2006
	:						06.05.2008
	:		Atmel AVR   SPI
	:							IAR Embedded Workbench

	      ,     SPI.
	!!! =>>>      
*/


#include "header.h"


/* ---  --- */
void spiMasterInit ( char Mode, char ClockRate, char Order )
{
	//MOSI, SS, SCK - , MISO -  
	SPI_DDR |= (1<<MOSI) | (1<<SCK);
	SPI_DDR &= ~(1<<MISO);
	#ifdef _SPI_USE_SS_
		SPI_DDR &= ~(1<<SS);
	#else
		SPI_DDR |= (1<<SS);
	#endif
	// 
	SPSR |= (ClockRate>>2)<<SPI2X;
	// SPI,   
	SPCR = (ClockRate & 0x03) | (1<<SPE) | (1<<MSTR) | (Mode<<CPHA) | (Order<<DORD);
}

void spiSend ( unsigned char Data )
{
	SPDR = Data;
	SPI_WAIT_FOR_COMPLETE;
}

unsigned char spiTransfer ( unsigned char Data )
{
	SPDR = Data;
	SPI_WAIT_FOR_COMPLETE;
	return SPDR;
}
