/*
	:								SPI.h
	:						   SPI   AVR
	:							 
	:							24.10.2006
	:						05.05.2008
	:		Atmel AVR   SPI
	:							IAR Embedded Workbench

	      ,     SPI.
	!!! =>>>      
*/


#ifndef SPI_H
#define SPI_H


/* ---  --- */
//
#ifndef _SPI_DEFS_
	#define SPI_DDR									DDRB
	#define SPI_PORT								PORTB
	#define SPI_PIN									PINB
	#ifdef __ATmega128__
		#define SCK										1
		#define MISO									3
		#define MOSI									2
		#define SS										0
	#elif __ATmega8__
		#define SCK										5
		#define MISO									4
		#define MOSI									3
		#define SS										2
	#else
		#define SCK										7
		#define MISO									6
		#define MOSI									5
		#define SS										4
	#endif
#endif

#define SPI_INT_ENA							SPCR |= (1<<SPIE)
#define SPI_INT_DIS							SPCR &= ~(1<<SPIE)
#define SPI_ENABLE							SPCR |= (1<<SPE)
#define SPI_DISABLE							SPCR &= ~(1<<SPE)
#define SPI_SET_MSB_FIRST				SPCR &= ~(1<<DORD)
#define SPI_SET_LSB_FIRST				SPCR |= (1<<DORD)

#define SPI_WAIT_FOR_COMPLETE		while(!(SPSR & (1<<SPIF)))
// 
#define POLRISING_PHASAMPLE			0
#define POLRISING_PHASETUP			1
#define POLFALLING_PHASAMPLE		2
#define POLFALLING_PHASETUP			3
#define SPI_MODE_0							0
#define SPI_MODE_1							1
#define SPI_MODE_2							2
#define SPI_MODE_3							3
//   
#define SPI_MSB_FIRST						0
#define SPI_LSB_FIRST						1
//   SCK
#define SPI_CLK_2								4
#define SPI_CLK_4								0
#define SPI_CLK_8								5
#define SPI_CLK_16							1
#define SPI_CLK_32							6
#define SPI_CLK_64							2
#define SPI_CLK_128							3


/* ---  --- */
extern void spiMasterInit ( char Mode, char ClockRate, char Order );
extern void spiSend ( unsigned char Data );
extern unsigned char spiTransfer ( unsigned char Data );

/* ---  --- */
#pragma vector=SPI_STC_vect
__interrupt extern void SPI_STC_intr ( void );

#endif
