/*
	:								timer0.h
	:						   0   AVR
	:							 
	:							22.05.2007
	:						22.05.2008
	:		Atmega8
	:							IAR Embedded Workbench
*/


/* ---  --- */
#define TIMER_0									TCNT0
#define TMR0_START							TCCR0 = (TCCR0 & 0xF8) | Timer0_clock
#define TMR0_STOP								TCCR0 &= ~(3<<CS00)
	// 
#define TMR0_OVF_INT_ENA				TIMSK |= (1<<TOIE0)
#define TMR0_OVF_INT_DIS				TIMSK &= ~(1<<TOIE0)
	// CLK
#define TMR0_NO_CLK							0
#define TMR0_NO_PRESCALING			1
#define TMR0_CLK_8							2
#define TMR0_CLK_64							3
#define TMR0_CLK_256						4
#define TMR0_CLK_1024						5
#define TMR0_EXT_FALLING				6
#define TMR0_EXT_RISING					7


/* ---  --- */
extern unsigned char Timer0_preload;
extern unsigned char Timer0_clock;


/* ---  --- */
extern void timer0Init ( unsigned char TimerClock, unsigned char TimerPreload );


/* ---  --- */
#pragma vector=TIMER0_OVF_vect
__interrupt extern void TIMER0_OVF_intr ( void );
