/*
	:								USART.h
	:						   USART   AVR
	:							 
	:							30.05.2007
	:						09.06.2008
	:		Atmega8
	:							IAR Embedded Workbench
*/


/* ---  --- */
//  
#define USART_RX_ENA										UCSRB |= (1<<RXEN);		// 
#define USART_RX_DIS										UCSRB &= ~(1<<RXEN)		// 
#define USART_TX_ENA										UCSRB |= (1<<TXEN);		// 
#define USART_TX_DIS										UCSRB &= ~(1<<TEXEN)	// 
#define USART_TXC_INT_ENA								UCSRB |= (1<<TXCIE)		//    
#define USART_TXC_INT_DIS								UCSRB &= ~(1<<TXCIE)	//    
#define USART_RXC_INT_ENA								UCSRB |= (1<<RXCIE)		//    
#define USART_RXC_INT_DIS								UCSRB &= ~(1<<RXCIE)	//    

#define WAIT_FOR_RECEIVE_COMPLETE				while (!(UCSRA & (1<<RXC)))	// 
#define WAIT_FOR_TRANSMIT_COMPLETE			while (!(UCSRA & (1<<TXC)))	// 
#define USART_WAIT_FOR_EMPTY						while (!( UCSRA & (1<<UDRE)))	//   
// 
#ifndef CPU_clock_freq
	#define CPU_clock_freq								9216000
#endif
#ifdef _USART_BAUDRATES_
#define USART_150												( (CPU_clock_freq/(2400))-1 )
	#define USART_300											( (CPU_clock_freq/(4800))-1 )
	#define USART_600											( (CPU_clock_freq/(9600))-1 )
	#define USART_1200										( (CPU_clock_freq/(19200))-1 )
	#define USART_2400										( (CPU_clock_freq/(38400))-1 )
	#define USART_4800										( (CPU_clock_freq/(76800))-1 )
	#define USART_9600										( (CPU_clock_freq/(153600))-1 )
	#define USART_19200										( (CPU_clock_freq/(307200))-1 )
	#define USART_38400										( (CPU_clock_freq/(614400))-1 )
	#define USART_57600										( (CPU_clock_freq/(921600))-1 )
	#define USART_115200									( (CPU_clock_freq/(1843200))-1 )
#endif


/* ---  --- */
// 
#define _1_STOP_BITS										0
#define _2_STOP_BITS										1
#define NO_PARITY												0
#define EVEN_PARITY											2
#define ODD_PARITY											3
#define CHSIZE_5												0
#define CHSIZE_6												1
#define CHSIZE_7												2
#define CHSIZE_8												3


/* ---  --- */
extern void usartInit( unsigned int Baudrate, char CharSize, char Parity, char StopBits );
extern void usartTransmit( unsigned char data );
extern unsigned char usartReceive( void );


/* ---  --- */
#pragma vector=USART_RXC_vect
__interrupt extern void USART_RXC_intr(void);

#pragma vector=USART_TXC_vect
__interrupt extern void USART_TXC_intr(void);
