/*------------------------------------------------------------------------------
	 buffer.h
	      buffer.c   
		 
	: 30.08.2007
	: 27.11.2007
------------------------------------------------------------------------------*/


#ifndef BUFFER_H
#define BUFFER_H


/* ---  --- */
#ifndef CRITICAL_SECTION_START
	#define CRITICAL_SECTION_START	unsigned char _sreg = SREG; __disable_interrupt()
	#define CRITICAL_SECTION_END	SREG = _sreg
#endif


/* ---  --- */
typedef struct struct_cBuffer
{
	unsigned char *Dataptr;			//  
	unsigned int Size;				// 
	unsigned int Datalength;	//   
	unsigned int Dataindex;		//   
} cBuffer;


/* ---   --- */
extern void	bufferInit(cBuffer* buffer, unsigned char * Start, unsigned int Size);
extern void  bufferGetFromFront(cBuffer * Buffer, unsigned char * Data, unsigned int ByteCount);
extern void	bufferDumpFromFront(cBuffer * Buffer, unsigned int Numbytes);
extern unsigned char	bufferGetAtIndex(cBuffer * Buffer, unsigned int Index);
extern unsigned char	bufferAddToEnd(cBuffer * Buffer, unsigned char Data);
extern unsigned char bufferAddDataBlock(cBuffer * Buffer, unsigned char * Data, unsigned int ByteCount);
extern unsigned int	bufferIsNotFull(cBuffer * Buffer);
extern void	bufferFlush(cBuffer * Buffer);
extern void bufferChangeAtIndex(cBuffer * Buffer, unsigned int Index, unsigned char Data);

#endif
